// DHTMLEventSink.cpp : implementation file
//

#include "stdafx.h"
#include "mshtmlhook.h"
#include "DHTMLEventSink.h"

#include "MshtmlhookDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDHTMLEventSink

IMPLEMENT_DYNCREATE(CDHTMLEventSink, CCmdTarget)

CDHTMLEventSink::CDHTMLEventSink()
{
	EnableAutomation();
}

CDHTMLEventSink::~CDHTMLEventSink()
{
}


void CDHTMLEventSink::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CDHTMLEventSink, CCmdTarget)
	//{{AFX_MSG_MAP(CDHTMLEventSink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDHTMLEventSink, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CDHTMLEventSink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	    DISP_FUNCTION_ID(CDHTMLEventSink,"HTMLELEMENTEVENTS2_ONCLICK", DISPID_HTMLELEMENTEVENTS2_ONCLICK, OnBClick, VT_EMPTY, VTS_DISPATCH)
        DISP_FUNCTION_ID(CDHTMLEventSink,"HTMLELEMENTEVENTS2_ONMOUSEOVER", DISPID_HTMLELEMENTEVENTS2_ONMOUSEOVER, OnBMouseOver, VT_EMPTY, VTS_DISPATCH)
        DISP_FUNCTION_ID(CDHTMLEventSink,"HTMLELEMENTEVENTS2_ONMOUSEMOVE", DISPID_HTMLELEMENTEVENTS2_ONMOUSEMOVE, OnBMouseMove, VT_EMPTY, VTS_DISPATCH)
        DISP_FUNCTION_ID(CDHTMLEventSink,"HTMLELEMENTEVENTS2_ONDBLCLICK", DISPID_HTMLELEMENTEVENTS2_ONDBLCLICK, OnBDblClick, VT_EMPTY, VTS_DISPATCH)
        DISP_FUNCTION_ID(CDHTMLEventSink,"HTMLELEMENTEVENTS2_ONMOUSEUP", DISPID_HTMLELEMENTEVENTS2_ONMOUSEUP, OnBMouseDown, VT_EMPTY, VTS_DISPATCH)
        DISP_FUNCTION_ID(CDHTMLEventSink,"HTMLELEMENTEVENTS2_ONMOUSEDOWN", DISPID_HTMLELEMENTEVENTS2_ONMOUSEDOWN, OnBMouseUp, VT_EMPTY, VTS_DISPATCH)

		
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDHTMLEventSink to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {B85F03A1-0375-4228-B4B0-CBAB1CBF9DCF}
static const IID IID_IDHTMLEventSink =
{ 0xb85f03a1, 0x375, 0x4228, { 0xb4, 0xb0, 0xcb, 0xab, 0x1c, 0xbf, 0x9d, 0xcf } };

BEGIN_INTERFACE_MAP(CDHTMLEventSink, CCmdTarget)
	INTERFACE_PART(CDHTMLEventSink, DIID_HTMLButtonElementEvents2, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDHTMLEventSink message handlers

STDMETHODIMP CDHTMLEventSink::Invoke(DISPID dispIdMember, REFIID, LCID, WORD, DISPPARAMS *pDisp, VARIANT* pReturn, EXCEPINFO *, UINT *)
{

  LPDISPATCH pDispElem = pReturn->pdispVal;

  IHTMLEventObj* pEvtObj;
	  
  HRESULT hr = pDispElem->QueryInterface(IID_IHTMLEventObj, (void**)&pEvtObj);


   switch(dispIdMember)
   {

      case DISPID_HTMLELEMENTEVENTS2_ONCLICK: 
   	   
			   OnBClick(pEvtObj);
			   
			   break; 
   
     case DISPID_HTMLELEMENTEVENTS2_ONMOUSEOVER: 
   	   
			   OnBMouseOver(pEvtObj);
			   
			   break; 

	case DISPID_HTMLELEMENTEVENTS2_ONMOUSEMOVE: 
   	   
			   OnBMouseMove(pEvtObj);
			   
			   break; 

	case DISPID_HTMLELEMENTEVENTS2_ONDBLCLICK: 
   	   
			   OnBDblClick(pEvtObj);
			   
			   break; 
   
   case DISPID_HTMLELEMENTEVENTS2_ONMOUSEUP: 
   	   
			   OnBMouseUp(pEvtObj);
			   
			   break; 

  case DISPID_HTMLELEMENTEVENTS2_ONMOUSEDOWN: 
   	   
			   OnBMouseDown(pEvtObj);
			   
			   break; 
   
   
   }

  return S_OK;

}



void CDHTMLEventSink::OnBClick(IHTMLEventObj *pEvtObj)
{
    	
	CString elemInfo("OnClick Event | Element=");
	
	BSTR bstrTag = 0;
    
	BSTR bstrId = 0;
    
	BSTR bstrAt = 0;
    
	VARIANT bstrValue;

	
	//get the element object who fire current event.
	IHTMLElement* pElem;
		
	pEvtObj->get_srcElement(&pElem);
	
	
	//get Button value.
	CString strAt("VALUE");
	
	bstrAt = strAt.AllocSysString();
	
	pElem->getAttribute(bstrAt,1,&bstrValue );

	BSTR reVal = bstrValue.bstrVal;

    CString strReVal(reVal);
	
	//get Button id
	pElem->get_id(&bstrId);

    CString strId(bstrId);
	
	//get tag name
	pElem->get_tagName(&bstrTag);
	
	CString strTag(bstrTag);
	
	//object release.
	SysFreeString(bstrId);

	SysFreeString(bstrAt);

	SysFreeString(bstrTag);
	
	SysFreeString(reVal);	
	
    elemInfo = elemInfo+strTag+";id= "+strId+";Value= "+strReVal;

    //get main dialog window object.
	CMshtmlhookDlg* mainDlg = (CMshtmlhookDlg*)m_pWnd;

	mainDlg->DisplayEvent(elemInfo);
    


}

void CDHTMLEventSink::SetParent(CWnd* objWnd)
{
    m_pWnd = objWnd;
	
}

void CDHTMLEventSink::OnBMouseOver(IHTMLEventObj *pEvtObj)
{

   CString elemInfo("OnMouseOver Event | Element=");
	
	BSTR bstrTag = 0;
    
	BSTR bstrId = 0;
    
	BSTR bstrAt = 0;
    
	VARIANT bstrValue;

	
	//get the element object who fire current event.
	IHTMLElement* pElem;
		
	pEvtObj->get_srcElement(&pElem);
	
	
	//get Button value.
	CString strAt("VALUE");
	
	bstrAt = strAt.AllocSysString();
	
	pElem->getAttribute(bstrAt,1,&bstrValue );

	BSTR reVal = bstrValue.bstrVal;

    CString strReVal(reVal);
	
	//get Button id
	pElem->get_id(&bstrId);

    CString strId(bstrId);
	
	//get tag name
	pElem->get_tagName(&bstrTag);
	
	CString strTag(bstrTag);
	
	//object release.
	SysFreeString(bstrId);

	SysFreeString(bstrAt);

	SysFreeString(bstrTag);
	
	SysFreeString(reVal);	
	
    elemInfo = elemInfo+strTag+";id= "+strId+";Value= "+strReVal;

    //get main dialog window object.
	CMshtmlhookDlg* mainDlg = (CMshtmlhookDlg*)m_pWnd;

	mainDlg->DisplayEvent(elemInfo);



}

void CDHTMLEventSink::OnBMouseMove(IHTMLEventObj *pEvtObj)
{

	CString elemInfo("OnMouseMove Event | Element=");
	
	BSTR bstrTag = 0;
    
	BSTR bstrId = 0;
    
	BSTR bstrAt = 0;
    
	VARIANT bstrValue;

	
	//get the element object who fire current event.
	IHTMLElement* pElem;
		
	pEvtObj->get_srcElement(&pElem);
	
	
	//get Button value.
	CString strAt("VALUE");
	
	bstrAt = strAt.AllocSysString();
	
	pElem->getAttribute(bstrAt,1,&bstrValue );

	BSTR reVal = bstrValue.bstrVal;

    CString strReVal(reVal);
	
	//get Button id
	pElem->get_id(&bstrId);

    CString strId(bstrId);
	
	//get tag name
	pElem->get_tagName(&bstrTag);
	
	CString strTag(bstrTag);
	
	//object release.
	SysFreeString(bstrId);

	SysFreeString(bstrAt);

	SysFreeString(bstrTag);
	
	SysFreeString(reVal);	
	
    elemInfo = elemInfo+strTag+";id= "+strId+";Value= "+strReVal;

    //get main dialog window object.
	CMshtmlhookDlg* mainDlg = (CMshtmlhookDlg*)m_pWnd;

	mainDlg->DisplayEvent(elemInfo);

    


}

void CDHTMLEventSink::OnBMouseDown(IHTMLEventObj *pEvtObj)
{
	CString elemInfo("OnMouseDown Event | Element=");
	
	BSTR bstrTag = 0;
    
	BSTR bstrId = 0;
    
	BSTR bstrAt = 0;
    
	VARIANT bstrValue;

	
	//get the element object who fire current event.
	IHTMLElement* pElem;
		
	pEvtObj->get_srcElement(&pElem);
	
	
	//get Button value.
	CString strAt("VALUE");
	
	bstrAt = strAt.AllocSysString();
	
	pElem->getAttribute(bstrAt,1,&bstrValue );

	BSTR reVal = bstrValue.bstrVal;

    CString strReVal(reVal);
	
	//get Button id
	pElem->get_id(&bstrId);

    CString strId(bstrId);
	
	//get tag name
	pElem->get_tagName(&bstrTag);
	
	CString strTag(bstrTag);
	
	//object release.
	SysFreeString(bstrId);

	SysFreeString(bstrAt);

	SysFreeString(bstrTag);
	
	SysFreeString(reVal);	
	
    elemInfo = elemInfo+strTag+";id= "+strId+";Value= "+strReVal;

    //get main dialog window object.
	CMshtmlhookDlg* mainDlg = (CMshtmlhookDlg*)m_pWnd;

	mainDlg->DisplayEvent(elemInfo);

}

void CDHTMLEventSink::OnBMouseUp(IHTMLEventObj *pEvtObj)
{
   
    CString elemInfo("OnMouseUp Event | Element=");
	
	BSTR bstrTag = 0;
    
	BSTR bstrId = 0;
    
	BSTR bstrAt = 0;
    
	VARIANT bstrValue;

	
	//get the element object who fire current event.
	IHTMLElement* pElem;
		
	pEvtObj->get_srcElement(&pElem);
	
	
	//get Button value.
	CString strAt("VALUE");
	
	bstrAt = strAt.AllocSysString();
	
	pElem->getAttribute(bstrAt,1,&bstrValue );

	BSTR reVal = bstrValue.bstrVal;

    CString strReVal(reVal);
	
	//get Button id
	pElem->get_id(&bstrId);

    CString strId(bstrId);
	
	//get tag name
	pElem->get_tagName(&bstrTag);
	
	CString strTag(bstrTag);
	
	//object release.
	SysFreeString(bstrId);

	SysFreeString(bstrAt);

	SysFreeString(bstrTag);
	
	SysFreeString(reVal);	
	
    elemInfo = elemInfo+strTag+";id= "+strId+";Value= "+strReVal;

    //get main dialog window object.
	CMshtmlhookDlg* mainDlg = (CMshtmlhookDlg*)m_pWnd;

	mainDlg->DisplayEvent(elemInfo);

}

void CDHTMLEventSink::OnBDblClick(IHTMLEventObj *pEvtObj)
{
    
   CString elemInfo("OnDblClick Event | Element=");
	
	BSTR bstrTag = 0;
    
	BSTR bstrId = 0;
    
	BSTR bstrAt = 0;
    
	VARIANT bstrValue;

	
	//get the element object who fire current event.
	IHTMLElement* pElem;
		
	pEvtObj->get_srcElement(&pElem);
	
	
	//get Button value.
	CString strAt("VALUE");
	
	bstrAt = strAt.AllocSysString();
	
	pElem->getAttribute(bstrAt,1,&bstrValue );

	BSTR reVal = bstrValue.bstrVal;

    CString strReVal(reVal);
	
	//get Button id
	pElem->get_id(&bstrId);

    CString strId(bstrId);
	
	//get tag name
	pElem->get_tagName(&bstrTag);
	
	CString strTag(bstrTag);
	
	//object release.
	SysFreeString(bstrId);

	SysFreeString(bstrAt);

	SysFreeString(bstrTag);
	
	SysFreeString(reVal);	
	
    elemInfo = elemInfo+strTag+";id= "+strId+";Value= "+strReVal;

    //get main dialog window object.
	CMshtmlhookDlg* mainDlg = (CMshtmlhookDlg*)m_pWnd;

	mainDlg->DisplayEvent(elemInfo);


}
